import java.awt.List;
import java.io.*;
import java.text.Collator;
import java.text.RuleBasedCollator;
import java.util.*;

class Writer 
{
	public static ArrayList<String> index;
	public static HashMap<String, ArrayList<String>> invertedindex = new HashMap<String,ArrayList<String>>();
	
	
	/*Teilt den Text in einzelne Wrter 
	und speichert diese in einer Hashmap 
	mit den Dokumenten in denen die Wrter zu finden sind*/
	public static  void Parser(File[] fileList) throws IOException
	{
		int i,j;
		int counter, counter2, ID;		
		counter2 = 0;
		ID = 0;
		
		
		
		for(File f : fileList)
		{
			ID++;
			FileInputStream fs = new FileInputStream(f);
			InputStreamReader isr2;
			BufferedReader fileInput;
			isr2 = new InputStreamReader(fs);
			fileInput = new BufferedReader(isr2);
			
			String b = fileInput.readLine();
			//String w[] = c.split(" ");

				while (b != null) 
				{	
				  counter = 0;
				  String v[] = b.split(" ");
				  
				  for(j=1;j<=v.length;j++)
				  {
					 if(v[j-1].length()==0 || v[j-1] == "*")
						 continue;
					 if(v[j-1].substring(v[j-1].length()-1,v[j-1].length()).equals(".") ||
							 v[j-1].substring(v[j-1].length()-1,v[j-1].length()).equals(",") ||
							 v[j-1].substring(v[j-1].length()-1,v[j-1].length()).equals("!") ||
							 v[j-1].substring(v[j-1].length()-1,v[j-1].length()).equals("?") ||
							 v[j-1].substring(v[j-1].length()-1,v[j-1].length()).equals(":"))
						 v[j-1]=v[j-1].substring(v[j-1].length()-1);
					 
					 if(!(invertedindex.containsKey(v[j-1])))
					 {
						 index = new ArrayList<String>();
						 index.add(f.getName());
						 invertedindex.put(v[j-1],index);
					 }
					 
					 else
					 {
						 index = invertedindex.get(v[j-1]);
						 if(index.contains(f.getName()))
							 continue;
						 else
						 {
						 index.add(f.getName());
						 invertedindex.put(v[j-1],index);
						 
						 }
					 }
							 
					}			  
				  
				  b=fileInput.readLine();
				  
			     }
			}
	}
	
	/*Ldt die Hashmap aus der gespeicherten Datei*/
	public static void LoadInvertedIndex(File f)
	{
		try{
		invertedindex = new HashMap<String,ArrayList<String>>();
		FileInputStream fin = new FileInputStream(f);
		ObjectInputStream ois = new ObjectInputStream(fin);
		invertedindex = (HashMap<String,ArrayList<String>>)ois.readObject();
		ois.close();
		}
		catch(Exception e) {e.printStackTrace();}
		
	}
	/*schreibt die Hashmap in eine Datei*/
	public static void WriteInvertedIndex(File f)
	{
		try{
			FileOutputStream fout = new FileOutputStream (f);
			ObjectOutputStream oos = new ObjectOutputStream(fout);
			oos.writeObject(invertedindex);
			oos.close();
		}
		catch(Exception e) {e.printStackTrace();}
		
	}
	
	/*Gibt die Schnittmenge der Listen 2er Wrter die zu betrachten sind*/
	public static ArrayList<String> Merge(String a, String b)
	{
		ArrayList<String> L1 = invertedindex.get(a);
		ArrayList<String> L2 = invertedindex.get(b);
		ArrayList<String> L3 = new ArrayList<String>();
		RuleBasedCollator RBC = (RuleBasedCollator)Collator.getInstance(Locale.GERMAN);
		int j = 1;
		int i = 1;
		
		
		while(i<=L1.size() && j<=L2.size())
		{
			if(RBC.compare(L1.get(i-1), L2.get(j-1))==0)
			{
				L3.add(L1.get(i-1));
				i++;
				j++;
			}
			else if(RBC.compare(L1.get(i-1), L2.get(j-1))<0)
			{
				i++;
			}
			else if(RBC.compare(L1.get(i-1), L2.get(j-1))>0)
			{
				j++;
			}
		}
		
		System.out.println(a+ " und " + b + " kommen in folgenden Dokumenten vor: " + L3);
		
		return L1;
	}

	
	public static void counter()
	{

		int k = invertedindex.size();
		ArrayList<String> L = new ArrayList<String>();
		HashMap<Integer, ArrayList<String>> occurancy = new HashMap<Integer,ArrayList<String>>();
		Iterator invertedkeys = invertedindex.keySet().iterator(); 
		ArrayList index2; 
		while(invertedkeys.hasNext())
		{
			String currentkey;
			currentkey = (String)invertedkeys.next();
			L = invertedindex.get(currentkey);
			int v = L.size();
			if(!(occurancy.containsKey(v)))
		 {
			 index2 = new ArrayList<String>();
			 index2.add(currentkey);
			 occurancy.put(v,index2);
		 }
		 
		 else
		 {
			 index2 = occurancy.get(v);
			 
			 index2.add(currentkey);
			 occurancy.put(v,index2);
			 
			 }
			
		 }
		
		TreeMap sortedOccurancy = new TreeMap(occurancy);
		Iterator treeIter = sortedOccurancy.entrySet().iterator();
	
		while(treeIter.hasNext())
		{
			Map.Entry count = (Map.Entry)treeIter.next();
			//L = (ArrayList)sortedOccurancy.get(count);
			System.out.print(count.getKey() + ", ");
			System.out.println(count.getValue());
			
		}
		}
	
	
	/*
	public static void Contains()
	{
		for(j=0; j<v.length;j++)
		{
		    //index.add(v[j]);
			if(v[j].equals(c))
			{
				//index.add(f.getName());
				counter = 1;
				counter2++;
				break;
			}
		}
		if(counter == 1)
		  break;
	}
		 
	*/

	public static void main(String arg[]) throws IOException
	{
		//Buffered Reader um die Tastatur einzulesen
		/*InputStreamReader isr;
		BufferedReader keyb;
		isr = new InputStreamReader(System.in);
		keyb = new BufferedReader(isr);
		*/
		//Hier soll die Hashmap gespeichert werden
		File f = new File("InvertedIndex.dat");
		
		//Alle Dateien einlesen und in ein Array einfgen
		File dir = new File("C:\\Users\\Jonas Krisch\\newDocs");
		File[] fileList = dir.listFiles();
		
		
		
		//Tastatur einlesen
		//System.out.print("Suche:");
		//String a = keyb.readLine();
		//String[] w = a.split(" ");
		
		
		Parser(fileList);
		counter();
		//Merge(w[0], w[1]);
		
	} 
	
}